////////////////////////////////////////////////////////////////////////////
//     (      )
// (   - funcrw.s
////////////////////////////////////////////////////////////////////////////
R_BZ_Script(mes,tip,ExtCod)
// -!!
//  R_BZ(, , _)
//  -    (CMN_SRC_REFS)  
{
  try
  {
    var ts = CreateObject("TempCommonSrc");
    ts.TempCommonSrcInitial(CMN_SRC_COUNT_LS);
    SetCommonProp(CMN_SRC_COUNT_LS,GetCommonProp(CMN_SRC_REFS));
    double rez=0.;
    poiskbzm(Extern_To_InternE(atof(ExtCod)),atoi(mes),rez,atoi(tip));
    return rez;
  }
  catch(object err)
  // 
  {
    SayError(err);                  //   
    return 0.;                  
  }
  catch(...)
  // 
  {
    SayUndefinedScriptError();
    return 0.;
  }  
}

GetDateVP(ExtCod,m,mv)
{
   double Cod = Extern_To_InternE(ExtCod);
   var Dat = CreateObject("KDate");
   Dat.SetDateD(GetDateFromFuncRWScript(m));
   int mabs = Dat.GetAbs();
   Dat.SetDateD(GetDateFromFuncRWScript(mv));
   int mvabs = Dat.GetAbs();
   var LS = CreateObject("LS");
   LS.GetGlobalLS();
   var MatrLS = LS.MatrLS();
   var Prop = CreateObject("APropBE");
   var SumElem = MatrLS.CollectSumm(Cod, mabs, mvabs, CL_EXACT|CL_M|CL_MV,Prop);
   return SumElem.Date.GetStr();
}

CalcTableAfterCreate(__AdrTable)
{
   var Tabl = CreateObject("CurPrnTbl");
   Tabl.Initial(__AdrTable);
   Tabl.Fill_Bottom_Text_2();
   //  17.02.2017  ,  ᤥ ᠬ  "ਥ "  ⠡
   // Tabl.Rewrite();
   return 0;
}

Correct_Address_Razn(&addrOEM, sz, what, how, tn, kchfld, date, param)
// addrOEM -   ( OEM )
// sz -  
// what -        (. 2-   )
// how -     (. 3-   )
// tn - ,      ( 0 -  )
// kchfld -   ,  
// date - ,   
// param -    (1)/  (0),  +2 -     
{
   int res=Correct_Address(addrOEM,sz,what,how);  

   if (res && tn>0 && !razovnum && strlen(kchfld)>0 && 
       ( (param&1)==0 || AmbaMessageBox("     ?","-௫",MB_YESNO|MB_ICONQUESTION,0)==IDYES) 
      )
   {
      int R_C = LSRead(tn,2); //2 -  ,    
      if ( R_C==1 ) 
         {
            var objDate=CreateObject("KDate");
            objDate.SetDate(static_cast_to_string(date));
            SetKchValue(kchfld, addrOEM, objDate);
            lswrite(ls,0);
         }
      }

   if (param&2) UpperString(addrOEM);
   return addrOEM;
}

CompareIndexWithKLADR(addrOEM)
{
   if (Str_Cmp(static_cast_to_string(addrOEM)," "," ,.-0")==0) return " ";
   var kadres=CreateObject("Adres");
   kadres.Initial(static_cast_to_string(addrOEM),0);
   int index=kadres.GetIndex();
   int indexKLADR=GetIndex(addrOEM);
   if (index==indexKLADR) return " ";
   switch (indexKLADR)
   {
      case 0: return "  ";
      case 1: return "  㪠,    ࠢ筨";
      case 2: return "   ࠢ筨";
      case 3: return "த   ࠢ筨";
      case 4: return "ᥫ 㭪   ࠢ筨";
      case 5: return "   ࠢ筨";   
      case 9: return "࠭ ⫨砥  ᨨ - ஫   ";
   } 
   char buf[15];
   sprintf(buf,indexKLADR);
   return buf;
}

Change_Index_Razn(addrOEM, indexStr, kchfld, date)
// addrOEM -      ( OEM )
// indexStr - ,   
// kchfld -   ,  
// date - ,   
{
   int index=atoi(static_cast_to_string(indexStr));
   if (Str_Cmp(static_cast_to_string(addrOEM)," "," ,.-0")==0) return;
   if (!index) return addrOEM;
   var kadres=CreateObject("Adres");
   kadres.Initial(static_cast_to_string(addrOEM),0);
   kadres.SetIndex(index);
   string param=kchfld;
   param+=",1,";
   param+=date;   
   return W_Face(param,kadres.GetAdres("_",""),255,0);
}

GetNameGroopUdForm425()
{
  UnLoadScriptModule("forms\\b425");
  LoadScriptModule("forms\\b425");
  ZaprosNameGroopUd();
  UnLoadScriptModule("forms\\b425");
}

IsMedCategory(kat)
{
   char s[256];
   GetCommonCnf("MedCat","egisz",s,255);
   if (!Str_Cmp(s," "," ")) return 1;
   var FuncParam =  CreateObject("ParamFuncRW");
   FuncParam.IInitial(static_cast_to_string(s),",",CatCount());
   int paramCount=FuncParam.Count();
   for (int param=0; param<paramCount; param++) 
     if (atoi(FuncParam.Get(param))==kat) return 1;
   return 0;
}

//     ,    cnfName   cnfTable   dateStart
//  decodeID==true,  ,     ID         GetKchValByIdFromRef
R_FaceCnfFld(cnfName, cnfTable, dateStart, decodeID)
{
   char name[256],s[256];
   GetCommonCnf(cnfName,cnfTable,name,255);
   FreeSpaceString(name,3,"");
   if (strlen(name)>0) 
   {
      R_Face(name+", "+dateStart,s,255,0);
      int num=kch_num_sys(name);
      if (decodeID && num>=0) 
         return GetKchValByIdFromRef(name,s,-1);
      return s;
   }
   else return "";
}

IsLSAttestWholePeriod()
{
  int len = 256;

  char ts[len], 
       arg[len], 
       str[len];

  var m1 = CreateObject("KMonth");
  var m2 = CreateObject("KMonth");

  m1.SetDate(static_cast_to_string(Str_Date_0));
  m2.SetDate(static_cast_to_string(Str_Date_1));

  var mes_rb = CreateObject("KMonth");
  var mes_uv = CreateObject("KMonth");

  kch_from("data_rb",str); FreeSpaceString(str,3,""); mes_rb.SetDate(static_cast_to_string(str));
  kch_from("data_uv",str); FreeSpaceString(str,3,""); mes_uv.SetDate(static_cast_to_string(str));

  int ames_rb = mes_rb.GetAbs();
  int ames_uv = mes_uv.GetAbs();

  int mbeg = m1.GetAbs(),
      mend = m2.GetAbs();

  int fatt = 1;

  //if ( !mes_uv.IsEqI(INVALID_MONTH_VALUE) ) if ( ames_uv < ames_rb ) fatt = 0;

  var mb = CreateObject("KMonth");

  if ( !mes_rb.IsEqI(INVALID_MONTH_VALUE) ) if ( ames_rb > mbeg ) mbeg = ames_rb;
  if ( !mes_uv.IsEqI(INVALID_MONTH_VALUE) ) if ( ames_uv < mend ) mend = ames_uv;

  for ( int mes = mbeg; mes <= mend; mes++ )
  { //   
    mb.SetMonth(mes);
    sprintf(ts,"%04d%02d.%02d", mb.GetYear(), mb.GetMonth(), mb.CountDay()); //   
    arg = "attest," + ts;
    //sprintf(arg,"attest,%s", ts);
    if ( 0 == atoi(R_Face(arg,str,14,0)) ) fatt = 0;
  }

  return fatt;
}

var GlobalInfoForBLFromLS=GetNothing();

YearPeriods896(FirstCall)
{
   GlobalInfoForBLFromLS=GetNothing();
   GlobalInfoForBLFromLS=CreateObject("KOtherEnterpriseReferenceBL");
   var Periods = CreateObject("KDatePeriods");
   Periods.Clear();
   var kcp = CreateObject("KPeriodsIterations");
   kcp.ClearAll();
   string sd0=Str_Date_0, sd1=Str_Date_1;
   if ( FirstCall && AskPeriod(0x144," ਮ   ᢥન")==ESC ) 
      BreakTableReceive();
   var Month = CreateObject("KMonth");
   Month.SetDate(SysStrDateOneScript);
   int Year1 = Month.GetYear();
   Month.SetDate(SysStrDateTwoScript);
   int Year2 = Month.GetYear();
   for ( int Year=Year1; Year<=Year2; ++Year )
   {
       string strYear = static_cast_to_string(Year);
       string D1 = "01.01."+strYear;
       string D2 = "31.12."+strYear;
       kcp.AddPeriod(strYear,D1,D2);
       Periods.Update(D1,D2);
   }
   GlobalInfoForBLFromLS.WorkPeriods()=Periods;
   GlobalInfoForBLFromLS.CollectFromLS("01.01."+to_string(Year1),"31.12."+to_string(Year2));
   Str_Date_0=sd0, Str_Date_1=sd1;
}

GetSumm896LS(Year) { return IsNothing(GlobalInfoForBLFromLS)?0.:GlobalInfoForBLFromLS.GetYearInfo(atoi(to_string(Year))).Summa; }
GetRv896LS(Year)   { return IsNothing(GlobalInfoForBLFromLS)?0.:GlobalInfoForBLFromLS.GetYearInfo(atoi(to_string(Year))).ExcludeDays; }

GetSumm896(Year) { return GetSummRv896(Year,0); }
GetRv896(Year)   { return GetSummRv896(Year,2); }

GetSummRv896(Year,FlagRv)
{
  char Buf[256];
  GetCommonCnf("LST_NU_DRO","",Buf,255);
  var ArrayNU;
  int cntNU=ListNUToSafeArray(Buf,' ',ArrayNU);
  var Month = CreateObject("KMonth");
  Month.SetMonthYear(1,static_cast_to_int(Year));
  int absm1=Month.GetAbs();
  Month.SetMonthYear(12,static_cast_to_int(Year));
  int absm2=Month.GetAbs();
  double Sum=0.;
  int Flag = 32+64+FlagRv;
  for ( int i=0; i<cntNU; ++i )
     Sum+=CashSumm(0,ArrayNU[i],absm1,absm2,Flag,CL_M,0);
  return Sum;
}

GetSumm896Spr(Year)
{
   var OtherReferences=CreateObject("KOtherEnterprisesCollectionReferences");
   OtherReferences.LoadFromLS();
   return OtherReferences.CollectInfoBLByYear(static_cast_to_int(Year)).Summa();
}

GetRv896Spr(Year)
{
   var OtherReferences=CreateObject("KOtherEnterprisesCollectionReferences");
   OtherReferences.LoadFromLS();
   return OtherReferences.CollectInfoBLByYear(static_cast_to_int(Year)).ExcludeDays();
}

ExcludedDaysForBL(Year,DateSp)
{
   string StrBegYear = "01.01."+static_cast_to_string(Year);
   string StrEndYear = "31.12."+static_cast_to_string(Year);
   int Holidays=0, MinusH=0, All=0;
   var ExclPeriods=CalcMinusDni(StrBegYear,StrEndYear,"",to_string(DateSp),Holidays,MinusH,1,0,All);
   return ExclPeriods.CountDays();
}

SaveInfoForBLAsSprav(Rcr)
{
   var Tbl=CreateObject("CurPrnTbl");
   int FldTN=Tbl.Find_Name_Fld("C_FIO");
   if ( FldTN==-1 ) return 0;
   int TN=atoi(Tbl.Text(FldTN,Rcr));

   var OneRefBL= CreateObject("KOtherEnterpriseReferenceBL");
   // var Periods = CreateObject("KDatePeriods");
   // Periods.Clear();
   // Periods.Update(static_cast_to_string(D1),static_cast_to_string(D2));
   // OneRefBL.WorkPeriods()=Periods;
   // OneRefBL.CollectFromLS(static_cast_to_string(D1),static_cast_to_string(D2));
   string NumSpr = Tbl.TextS("NumSp",Rcr); FreeSpaceString(NumSpr,2,"");
   OneRefBL.NumCertificate()=NumSpr;
   string DSpr = Tbl.TextS("DateSp",Rcr); FreeSpaceString(DSpr,2,"");
   OneRefBL.DateCertificate()=DSpr;

   
   int FldYear=Tbl.Find_Name_Fld("Year1");
   int FldSum=Tbl.Find_Name_Fld("Summ1");
   int FldRv = Tbl.Find_Name_Fld("Exclude1");
   // int FldRv = Tbl.Find_Name_Fld("Rv");
   for ( int idxYear=0; idxYear<10; ++idxYear )
   {
      int Year = atoi(Tbl.Text(FldYear+idxYear,Rcr));
      if ( Year<1 ) break;
      var OneYear = CreateObject("KOtherEnterpriseInfoBLOneYear");
      OneYear.Summa()=atof(Tbl.Text(FldSum+idxYear*3,Rcr));
      if ( FldRv==-1 )
         OneYear.ExcludeDays=0;
      else
      {
         int Rv = atoi(Tbl.Text(FldRv+idxYear,Rcr));
         if ( Rv<0 ) Rv=0;
         OneYear.ExcludeDays=Rv;
      }
      OneYear.ChangeYear(Year);
      OneRefBL.AddYearInfo(OneYear);
   }

   var OtherReferences=CreateObject("KOtherEnterprisesCollectionReferences");
   OtherReferences.LoadFromLS();
   OtherReferences.InsertBLReference(OneRefBL);
   OtherReferences.SaveToLS();
}

var MapTnDone896;
SaveDiff896Spr(__Rcr,NumSpr,DSpr)
{
   int Rcr = static_cast_to_int(__Rcr);
   if ( !Rcr )
   {
      MapTnDone896 = CreateObject("MapString");
      MapTnDone896.Clear();
   }
   var Tbl=CreateObject("CurPrnTbl");
   int FldTN=Tbl.Find_Name_Fld("C_FIO");
   int CurTN = FldTN!=-1?atoi(Tbl.Text(FldTN,Rcr)):0;
   if ( MapTnDone896.IsExist(static_cast_to_string(CurTN)) ) return 0;
   MapTnDone896.Add(static_cast_to_string(CurTN),static_cast_to_string(Rcr));

   var OneRefBL= CreateObject("KOtherEnterpriseReferenceBL");
   // var Periods = CreateObject("KDatePeriods");
   // Periods.Clear();
   // Periods.Update(static_cast_to_string(D1),static_cast_to_string(D2));
   // OneRefBL.WorkPeriods()=Periods;
   // OneRefBL.CollectFromLS(static_cast_to_string(D1),static_cast_to_string(D2));
   OneRefBL.NumCertificate()=static_cast_to_string(NumSpr);
   OneRefBL.DateCertificate()=static_cast_to_string(DSpr);

   
   int FldYear=Tbl.Find_Name_Fld("Year");
   int FldSum=Tbl.Find_Name_Fld("Summa");
   int FldRv = Tbl.Find_Name_Fld("Rv");
   for ( int iRcr=Rcr; iRcr<Tbl.Count_Rcr(); ++iRcr )
   {
      int TN = FldTN!=-1?atoi(Tbl.Text(FldTN,iRcr)):0;
      if ( TN!=CurTN ) continue;

      var OneYear = CreateObject("KOtherEnterpriseInfoBLOneYear");
      OneYear.Summa()=FldSum!=-1?atof(Tbl.Text(FldSum,iRcr)):0.;
      int Rv = FldRv!=-1?atoi(Tbl.Text(FldRv,iRcr)):0;
      if ( Rv<0 ) Rv=0;
      OneYear.ExcludeDays=Rv;
      OneYear.ChangeYear(FldYear!=-1?atoi(Tbl.Text(FldYear,iRcr)):0);
      OneRefBL.AddYearInfo(OneYear);
   }

   var OtherReferences=CreateObject("KOtherEnterprisesCollectionReferences");
   OtherReferences.LoadFromLS();
   OtherReferences.InsertBLReference(OneRefBL);
   OtherReferences.SaveToLS();
   return 0;
}

p3getCol(psev,pole)
{
  char str[1024];
  GetCommonCnf(pole,psev,str,20);
  FreeSpaceString(str,3,"");
  // 稬 ⮫  "짮⥫᪮" 㬥樨 (㬥  1).
  //  ᯮ짮 : 
  // 1) ஢  㫥 (᫨  - ⮫  )
  // 2)  ⠭  ਯ⮢ 㭪樨  1 (..   㬥  ).
  int Col = GetCnfCol(str,-1) + 1;

  return Col;
}

TVHColFromCnf(cnfTable, cnfName)
{
   return p3getCol(cnfTable, cnfName);
}

getSummOtchet(arg,FlagCalc)
//FlagCalc==1 -  R_Tax,  頥 ࠭ ⠭
//arg - ப 㬥⮢  R_tax:
/*
1   - ⨯ 祭 ( ⨬ ).  祭:
  ""
  "।쭮"
  "࠭祭।쭮"
  "륂믫"
  "ᥣ᫥"
2,3 - ਮ 롮ન
4   - ᨬ 
5   - ,   砥 祭 ஥  
*/
{
  //1 ࠬ - ⨯ 祭
  var Param = CreateObject("ParamFuncRW");     // ᮧ ꥪ  ParamFuncRW 
  Param.IInitial(to_string(arg),",",9);
  char What[256];What=Param.Get(0);FreeSpaceString(What,3,"");
  if (!strlen(What)) return 0.0;
  
  //2  3 ࠬ -  롮ન
  int mb,me;mb=me=0;   // 砫/砭 (⭮⥫)
  var dat = CreateObject("KDate");  
  if (Param.Count()>1) 
  {
    dat.SetDateD(GetDateFromFuncRWScript(Param.Get(1)));
    me=mb=dat.GetAbs()-mtek;
  }
  if (Param.Count()>2) 
  {
    dat.SetDateD(GetDateFromFuncRWScript(Param.Get(2)));
    me=dat.GetAbs()-mtek;
  }
  //4 ࠬ - ᨬ 
  char SimNal='';
  if (Param.Count()>3) 
  {
    char s[256]; s=Param.Get(3);
    SimNal=s[0];
  }
  
  //5 ࠬ -,   砥 祭 ஥   
  dat.SetDateII(1,mb+mtek);//,   砥 祭 ஥  
  if (Param.Count()>4) dat.SetDate(Param.Get(4));
  
  char Arg[256],Str[256];
  sprintf(Arg,"4,1,%d,%d,*,*,%c,DateTaxCnf=%s",mb,me,SimNal,dat.GetStr());
  R_Tax(Arg,Str,14,2);
  
  if (What=="")
    return atof(RTSx(4,14,2))
          +atof(RTSx(80,14,2));

  if (What=="।쭮")
  return atof(RTSx(160,14,2))
        +atof(RTSx(161,14,2));

  if (What=="࠭祭।쭮")
  return  atof(RTSx(4,14,2))
         +atof(RTSx(80,14,2))
         -atof(RTSx(160,14,2))
         -atof(RTSx(161,14,2));
        
  if (What=="륂믫")
    return atof(res2("2200",14,2))
          +atof(res2("2100",14,2))
          +atof(RTSx(71,14,2))
          -atof(RTSx(80,14,2));
  
  if (What=="ᥣ᫥")
  return atof(RTSx(4,14,2))
        +atof(res2("2200",14,2))
        +atof(res2("2100",14,2))
        +atof(RTSx(71,14,2));
  return 0.0;
}
SendKvitokToEmail()
{
  try
  {
    int sendEmail=GetCommonCnfInt("sendEmail","⮪");
    //᫨ ப  㫥
    if (sendEmail)
    {
      int obr_kv=atoi(GetVarValue("_")); 
      int vib_kv=atoi(GetVarValue("_")); 

      //᫨  ன 1 -  ࠡ⪥ 1 ⪠ 뤠 
      if (atoi(obr_kv)==0)
      {
        bool askAboutSend=GetCommonCnfInt("sendEmail","⮪") & 0x01;
        ReLoadScriptModule("Check\\checksToEmail");
        if ( !askAboutSend || askAboutSend && AmbaMessageBox("ࠢ ⪨  ?","",MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2, 0)==IDYES ) 
        {
          kvitokToEmail=1;
          InitOffsets(vib_kv);  
        }
     }
     //ࠢ塞 ⪨
     if(kvitokToEmail)
     {
         CountOffsetsForKvitokToEmail++;                                 //- ᬥ饭(⪮)
         var CFile=CreateObject("CurPrnFile");
         OffsetsForKvitokToEmail[CountOffsetsForKvitokToEmail]=CFile.GetCountByte(); //   ⪠
         
         char tmp[256];kch_from("e_mail",tmp);FreeSpaceString(tmp,3,"");
         EmailsForKvitokToEmail [CountOffsetsForKvitokToEmail]=tmp;// ⮢ 
         //䨮
         kch_from("f",tmp); FreeSpaceString(tmp,3,"");
         string FIO=tmp+" ";
         kch_from("i",tmp); FreeSpaceString(tmp,3,"");
         FIO+=tmp+" ";
         kch_from("o",tmp); FreeSpaceString(tmp,3,"");
         FIO+=tmp; 
         
         kch_from("tn",tmp);FreeSpaceString(tmp,3,"");
         TnFioForKvitokToEmail  [CountOffsetsForKvitokToEmail]=to_string(tmp)+";"+FIO;//   
         
         CheckMonthForKvitokToEmail[CountOffsetsForKvitokToEmail]=atoi(GetVarValue("_"));
         //᫨ ࠡ⠫  ,
         if (atoi(obr_kv)+1==atoi(vib_kv))
             Send_Checks();     //ࠢ塞 ⪨  
      }
      if (atoi(obr_kv)+1==atoi(vib_kv))
         UnloadScriptModule("Check\\checksToEmail");//㦠 
    }
  }
  catch(...)
  {
    SayUndefinedScriptError();
    UnloadScriptModule("Check\\checksToEmail");//㦠 
    return; 
  }
}
var checkManager;
PrintNetChecks(param)
{
  return PriorityCall("UserPrintNetChecks","SysPrintNetChecks",param);
}
SysPrintNetChecks(param)
{

  int checksProcessed=atoi(param.GetValue("ChecksProcessed"));  
  int checksCount=atoi(param.GetValue("ChecksCount"));  
  var modules=GetArray("check\\comcheck","check\\comprint");
  try
  {
    if (checksProcessed==0)
    {
      var CFile=CreateObject("CurPrnFile"); // ꥪ   ࠡ  ⥪騬 䠩 
      CFile.SetFlagBrowse(0);               // 頥 ᬮ
      CFile.SetFlag_Print(0);               // ⥪⮢   㦭
      ReLoadSMs(modules);
      checkManager=NetDialogs().GetCheckManager();
      checkManager.Init(param);
    }
    month_kv=atoi(param.GetValue("CheckMonth"));   
    int month=month_kv;   //    ६  । :( 
    checkManager.PrintCheck(month);
    //  䠩  ⪮
    var filePath=checkManager.GetCheckFilePath();
    //ࠢ塞 ⮪
    if( param.IsExist("ExcelPrintMode") && atoi(param.GetValue("ExcelPrintMode"))==2 &&
        param.IsExist("CheckSaveOptions") && atoi(param.GetValue("CheckSaveOptions")) & 0x01 || atoi(param.GetValue("CheckSaveOptions")) & 0x02)
      SendNetCheck(filePath);
    if (checksProcessed+1==atoi(checksCount))
    {
      UnLoadSMs(modules);
      checkManager.EndPrint();
    }
  } 
  catch(...)  
  {
    SayUndefinedScriptError();
    UnLoadSMs(modules);
  }
}
SendNetCheck(filePath)
{
  // ன 㪠  ࠢ ⪨
  if( GetCommonCnfInt("sendEmail","⮪")==0 )
    return;
    
  //᫥  ࢮ ⪠ 뤠   ࠢ ⪮
  if( 0==atoi(GetVarValue("_")) )  
  {
    ReLoadScriptModule("Check\\checksToEmail");
    bool askAboutSend=GetCommonCnfInt("sendEmail","⮪") & 0x01;
    if ( !askAboutSend || askAboutSend && AmbaMessageBox("ࠢ ⪨  ?","",MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2, 0)==IDYES ) 
    {         
          kvitokToEmail=1;
      InitOffsets(0);
    }
  }
  //⪠  ࠢ
  if( !kvitokToEmail)
    return;
  
  string from="";// ࠢ⥫ 쬥  쪨  
  string email= kch_from_safe("e_mail");  
  var kd=KDateFromInt(atoi(GetVarValue("_")));
  string subject ="⮪  " + kd.NameMonth();   // ᮮ饭
  bool sendStatus=NetDialogs().SendMailExcel(from,email,OemToAnsi(subject),OemToAnsi(subject),filePath);    
  var infoForLog=MakeLogInfo(to_string(kch_from_safe("tn")),to_string(GetFioFromKch()),email,sendStatus);
  AddLogFile(fileNameForLog,infoForLog);
  if ( atoi(GetVarValue("_"))+1==atoi(GetVarValue("_")) )
  {
    AskAndShowLogChecks();
    UnloadScriptModule("Check\\checksToEmail");//㦠 
  } 
}
CheckSumForTaxExist(strDatB,strDatE,&Arr)
{   
   return PriorityCall("UsrCheckSumForTaxExist","SysCheckSumForTaxExist",strDatB,strDatE,Arr);
}

SysCheckSumForTaxExist(strDatB,strDatE,&Arr)
{
   char Arg[256],Str[256];
   var DatB = CreateObject("KDate");
   var DatE = CreateObject("KDate");
   DatB.SetDateD(GetDateFromFuncRWScript(strDatB));
   DatE.SetDateD(GetDateFromFuncRWScript(strDatE));
   sprintf(Arg,"7,1,%d,%d,*,*,%d,DateTaxCnf=%s",DatB.GetRel(),DatE.GetRel(),Arr[0],DatB.GetStr());
   R_Tax(Arg,Str,14,2);

   double Sum=atof(RTSx(4,14,2));
   // atof(RTSx(160,14,2))+atof(RTSx(161,14,2)); // ॢ襭
   // 
   string str1=Str_Date_0;
   string str2=Str_Date_1;
   Str_Date_0=strDatB;//DatB.GetStr();
   Str_Date_1=strDatE;//DatE.GetStr();
   Sum+=atof(res2("2200",14,2))+atof(res2("2100",14,2))+atof(RTSx(71,14,2));
   Str_Date_0=str1;
   Str_Date_1=str2;
   return Sum;
}
GetListPeriodsFromTabel(d1,d2,strSim)
//頥 ᯨ᮪   " 砫"-" 砭"-"⢮ ";" 砫"-" 砭"-"⢮ ";  ..
{
  string rez="";
  //..   ⮫쪮 ⠡  㪠 ᨬ -  祭 ஥ MINUS_DNI  MinusRV 
  //।⥫쭮 ࠭ ⥪騥 祭
  string oldMinusDni=GetCommonCnfStr("MINUS_DNI","");
  string oldMinusRv=GetCommonCnfStr("MinusRV","");
  try
  {
    SetCommonCnfInMem("MINUS_DNI",to_string(strSim),"",'C',strlen(strSim),0);
    SetCommonCnfInMem("MinusRV","1","",'C',1,0);
    
    int Holidays=0, MinusH=0, All=0;
    var ExclPeriods=CalcMinusDni(d1.GetStr(),d2.GetStr(),"",d2.GetStr(),Holidays,MinusH,1,0,All);
    int cntPer = ExclPeriods.Count();
    //横  ਮ
    for ( ExclPeriods.SetBegin(); !ExclPeriods.End(); ExclPeriods.Next())
    {
      string DBeg = (cntPer>0)?ExclPeriods.GetCurBeg().GetStr():"-";
      string DEnd = (cntPer>0)?ExclPeriods.GetCurEnd().GetStr():"-";
      int cntDays = (cntPer>0)?(ExclPeriods.GetCurEnd().Diff(ExclPeriods.GetCurBeg())+1):0;
      // 襬 ਮ
      char tmp[256];
      sprintf(tmp,"%s-%s-%s;",DBeg,DEnd,to_string(cntDays));   
      rez+=tmp;
    }
  }
  catch(...)
  {
    ;
  }
  //⠭ 祭
  SetCommonCnfInMem("MINUS_DNI",oldMinusDni,"",'C',strlen(oldMinusDni),0);
  SetCommonCnfInMem("MinusRV",oldMinusRv,"",'C',strlen(oldMinusRv),0);
  return rez;
}
AddCountToTableName(__AdrTable,__AdrMainTable,__MainTableRcr,text)
{
 try
  {
    if ( __AdrMainTable ) 
    {
      var Tabl = CreateObject("CurPrnTbl");
      Tabl.Initial(__AdrTable);
      int count=Tabl.Count_Rcr();

      var TablMain=CreateObject("CurPrnTbl");
      TablMain.Initial(__AdrMainTable);
      if ( __MainTableRcr>=0 && __MainTableRcr<TablMain.Count_Rcr() )
      {
        int Fld = TablMain.Find_Name_Fld("Descriptor");
        if ( Fld==-1 ) return;
        char caption[256],tmp[256];;
        caption = TablMain.Text(Fld,__MainTableRcr); FreeSpaceString(caption,3,"");
        sprintf(tmp,"%s (%s: %d)",caption,text,count);
        TablMain.SText(Fld,__MainTableRcr,to_string(tmp));
        TablMain.Rewrite();
      }
    }
  }
  catch(...)
  {
    ;
  } 
}
AddSummToTableName(__AdrTable,__AdrMainTable,__MainTableRcr,nameFld,text)
{
  PriorityCall("UserAddSummToTableName","SysAddSummToTableName",__AdrTable,__AdrMainTable,__MainTableRcr,nameFld,text);
}

AddSrednSummToTableName(__AdrTable,__AdrMainTable,__MainTableRcr,nameFld,text)
{
  PriorityCall("UserAddSrednSummToTableName","SysAddSrednSummToTableName",__AdrTable,__AdrMainTable,__MainTableRcr,nameFld,text);
}

SysAddSummToTableName(__AdrTable,__AdrMainTable,__MainTableRcr,nameFld,text)
{
   return SysAddSummToTableNameEx(__AdrTable,__AdrMainTable,__MainTableRcr,nameFld,text,0);
}

SysAddSrednSummToTableName(__AdrTable,__AdrMainTable,__MainTableRcr,nameFld,text)
{
   return SysAddSummToTableNameEx(__AdrTable,__AdrMainTable,__MainTableRcr,nameFld,text,1);
}

SysAddSummToTableNameEx(__AdrTable,__AdrMainTable,__MainTableRcr,nameFld,text,Type)
{
  try
  {
    if ( __AdrMainTable ) 
    {
      var Tabl = CreateObject("CurPrnTbl");
      Tabl.Initial(__AdrTable);
      int FldSumm = Tabl.Find_Name_Fld(nameFld);
      if(FldSumm==-1) return;
      int Acc=Tabl.Accurasy_Fld(FldSumm);
      
      Tabl.Fill_Bottom_Text_1();
      double Sum = atof(Tabl.Get_Bottom_Text(FldSumm));
      if ( Type==1 && Tabl.Count_Rcr() ) Sum /= Tabl.Count_Rcr();


      var TablMain=CreateObject("CurPrnTbl");
      TablMain.Initial(__AdrMainTable);
      if ( __MainTableRcr>=0 && __MainTableRcr<TablMain.Count_Rcr() )
      {
        int Fld = TablMain.Find_Name_Fld("Descriptor");
        if ( Fld==-1 ) return;
        char caption[256],tmp[256];;
        caption = TablMain.Text(Fld,__MainTableRcr); FreeSpaceString(caption,3,"");
        sprintf(tmp,"%s (%s: %.*f)",caption,text,Acc,Sum);
        TablMain.SText(Fld,__MainTableRcr,to_string(tmp));
        TablMain.Rewrite();
      }
    }
  }
  catch(...)
  {
    ;
  }  
}

kch_from_safe(kchField)
{
  char value[256];
  if(kch_num_sys(kchField)==-1) 
    value="";
  else
    kch_from(kchField,value);
  FreeSpaceString(value,3,"");
  return value;
}

int flagShowWarn_CardNumber=0; //뢠 ᮮ饭?
GetAndCheckNotNull_CardNumber(kchField)
{
  var value=kch_from_safe(kchField);
  if(strlen(value)<1 && !flagShowWarn_CardNumber) 
  {
    char message[256];
    sprintf(message," 㤭 \"%s\"  㪠  ⨪ !",GetFioFromKch()); 
    char caption[256];
    sprintf(caption,"! ᥢ  \"%s\"",kchField); 
    MsgBoxCheck(OemToAnsi(message),OemToAnsi(caption),MB_OK|MB_ICONERROR,OemToAnsi("  뢠  ᮮ饭"),flagShowWarn_CardNumber);      
  }
  // ௫ ஥⮢    
  return GetElementFromString(0,value,"^");
}

GetFioFromKch()
{
  char tmp[256],fio[256];
  kch_from("f",tmp); FreeSpaceString(tmp,3,"");  fio=tmp;
  kch_from("i",tmp); FreeSpaceString(tmp,3,"");  fio+=" "+tmp;
  kch_from("o",tmp); FreeSpaceString(tmp,3,"");  fio+=" "+tmp;
  return fio;

}

GetMestoRogd(version)
{
  switch (atoi(version))
  {
    default: // த,ࠩ,,࠭
    {
      char tmp[256],str[256];
      kch_from("gorod_r",tmp) ; FreeSpaceString(tmp,3,""); str=tmp;
      kch_from("rajon_r",tmp) ; FreeSpaceString(tmp,3,""); if ( tmp!="" ) str += ", "+tmp;
      kch_from("oblast_r",tmp); FreeSpaceString(tmp,3,""); if ( tmp!="" ) str += ", "+tmp;
      kch_from("strana_r",tmp); FreeSpaceString(tmp,3,""); if ( tmp!="" ) str += ", "+tmp;
      return to_string(str);
    }
  }  
}
//  ।  ᯨ᪠ ⠡
GetDirTransf(AdrCListTabl,RcrInList)
{
  //।  ⠡  ᯨ᪥ 蠡
  var ListTabl = CreateObject("CurPrnTbl");  ListTabl.Initial(AdrCListTabl);
  int fld = ListTabl.Find_Name_Fld("KindForm");
  if( fld==-1 ) return "";
  int tableNum=atoi(ListTabl.Text(fld,RcrInList));// 蠡
  return GetValueFromShablonList(tableNum,"DbfPath");
}
GetValueFromShablonList(tableNum,FieldName)
{
  //।   Db_Main.Sum ( ⮬ "⥢ ਠ")
  char zplPath[256]; //  zpl
  if (!IsLocalZPL()&& IsCommonResource(NameCommonDir()))
  GetCommonZPL(zplPath,255);
  else
  GetCurrentDirectory(255,zplPath);
  FreeSpaceString(zplPath,3,"");      
  string dbMainPath=zplPath+"\\"+NameCommonDir()+"\\Db_Main.Sum";
  
  //稬 祭   "   䠩  । ଠ樨  ⠡"
  var ShablonList = CreateObject("CurPrnTbl");  ShablonList.InitialNameFile(dbMainPath);
  int fldShablonNum = ShablonList.Find_Name_Fld("TableNum");
  int fldValue=ShablonList.Find_Name_Fld(to_string(FieldName));
  if( fldShablonNum==-1 || fldValue==-1 ) return "";
  for(int i=0;i<ShablonList.Count_Rcr();i++)
  {
    int curTableNum=atoi(ShablonList.Text(fldShablonNum,i));
    if (curTableNum==tableNum) //諨 ⠡  㦭 ஬
    {
      char s[256];s=ShablonList.Text(fldValue,i); FreeSpaceString(s,3,"");
      return s;
    }
  }
  return "";
}

AskForDates(dateBeg,dateEnd,comment)
{
   string saveStrDate0=Str_Date_0;
   string saveStrDate1=Str_Date_1;

   FreeSpaceString(dateEnd,3,"");
   int period=strlen(dateEnd)>0 ? 4 : 0;

   sprintf(Str_Date_0,"%.10s",dateBeg);
   sprintf(Str_Date_1,"%.10s",dateEnd);
   if (AskPeriod(512+256+2+period,comment)==0) return ESC; 
   dateBeg=Str_Date_0;
   dateEnd=Str_Date_1;
   strcpy(Str_Date_0,saveStrDate0);
   strcpy(Str_Date_1,saveStrDate1);
}
GetElementFromString(idx,str,delim)
{
  var List = CreateObject("ParamFuncRW");
  List.IInitial1(to_string(str),delim,255);
  if(List.Count()>idx) return List.Get(idx);
  return "";
}

//version==0 //"" ࠭᫨ 
//version==1 -   52535.1-2006
//version==2 -  7.79-2000 (22.06.2000)
SysTransliterationInit(version)
{
  var mapKey = CreateObject("MapString");
  mapKey.Clear();
  switch (atoi(version))
  {
    case 1:
          {
            mapKey.Add("","A");    mapKey.Add("","B");    mapKey.Add("","V");
            mapKey.Add("","G");    mapKey.Add("","D");    mapKey.Add("","E");
            mapKey.Add("","E");    mapKey.Add("","ZH");   mapKey.Add("","Z");
            mapKey.Add("","I");    mapKey.Add("","I");    mapKey.Add("","K");
            mapKey.Add("","L");    mapKey.Add("","M");    mapKey.Add("","N");
            mapKey.Add("","O");    mapKey.Add("","P");    mapKey.Add("","R");
            mapKey.Add("","S");    mapKey.Add("","T");    mapKey.Add("","U"); 
            mapKey.Add("","F");    mapKey.Add("","KH");   mapKey.Add("","TS");
            mapKey.Add("","CH");   mapKey.Add("","SH");   mapKey.Add("","SHCH");
            mapKey.Add("","IE");   mapKey.Add("","Y");    mapKey.Add("","");
            mapKey.Add("","E");    mapKey.Add("","IU");   mapKey.Add("","IA");
            
            mapKey.Add("","A");    mapKey.Add("","B");    mapKey.Add("","V");
            mapKey.Add("","G");    mapKey.Add("","D");    mapKey.Add("","E");
            mapKey.Add("","E");    mapKey.Add("","ZH");   mapKey.Add("","Z");
            mapKey.Add("","I");    mapKey.Add("","I");    mapKey.Add("","K");
            mapKey.Add("","L");    mapKey.Add("","M");    mapKey.Add("","N");
            mapKey.Add("","O");    mapKey.Add("","P");    mapKey.Add("","R");
            mapKey.Add("","S");    mapKey.Add("","T");    mapKey.Add("","U"); 
            mapKey.Add("","F");    mapKey.Add("","KH");   mapKey.Add("","TS");
            mapKey.Add("","CH");   mapKey.Add("","SH");   mapKey.Add("","SHCH");
            mapKey.Add("","IE");   mapKey.Add("","Y");    mapKey.Add("","");
            mapKey.Add("","E");    mapKey.Add("","IU");   mapKey.Add("","IA");
            break;          
          }
    case 2:
          {
            mapKey.Add("","A");    mapKey.Add("","B");    mapKey.Add("","V");
            mapKey.Add("","G");    mapKey.Add("","D");    mapKey.Add("","E");
            mapKey.Add("","YO");   mapKey.Add("","ZH");   mapKey.Add("","Z");
            mapKey.Add("","I");    mapKey.Add("","J");    mapKey.Add("","K");
            mapKey.Add("","L");    mapKey.Add("","M");    mapKey.Add("","N");
            mapKey.Add("","O");    mapKey.Add("","P");    mapKey.Add("","R");
            mapKey.Add("","S");    mapKey.Add("","T");    mapKey.Add("","U"); 
            mapKey.Add("","F");    mapKey.Add("","X");    mapKey.Add("","CZ");
            mapKey.Add("","CH");   mapKey.Add("","SH");   mapKey.Add("","SHH");
            mapKey.Add("","''");   mapKey.Add("","Y'");   mapKey.Add("","'");
            mapKey.Add("","E'");   mapKey.Add("","YU");   mapKey.Add("","YA");
            
            mapKey.Add("","A");    mapKey.Add("","B");    mapKey.Add("","V");
            mapKey.Add("","G");    mapKey.Add("","D");    mapKey.Add("","E");
            mapKey.Add("","YO");   mapKey.Add("","ZH");   mapKey.Add("","Z");
            mapKey.Add("","I");    mapKey.Add("","J");    mapKey.Add("","K");
            mapKey.Add("","L");    mapKey.Add("","M");    mapKey.Add("","N");
            mapKey.Add("","O");    mapKey.Add("","P");    mapKey.Add("","R");
            mapKey.Add("","S");    mapKey.Add("","T");    mapKey.Add("","U"); 
            mapKey.Add("","F");    mapKey.Add("","X");    mapKey.Add("","CZ");
            mapKey.Add("","CH");   mapKey.Add("","SH");   mapKey.Add("","SHH");
            mapKey.Add("","''");   mapKey.Add("","Y'");   mapKey.Add("","'");
            mapKey.Add("","E'");   mapKey.Add("","YU");   mapKey.Add("","YA");
            break;          
          }
    default:
          {
            mapKey.Add("","A");    mapKey.Add("","B");    mapKey.Add("","V");
            mapKey.Add("","G");    mapKey.Add("","D");    mapKey.Add("","E");
            mapKey.Add("","YO");   mapKey.Add("","G");    mapKey.Add("","Z");
            mapKey.Add("","I");    mapKey.Add("","J");    mapKey.Add("","K");
            mapKey.Add("","L");    mapKey.Add("","M");    mapKey.Add("","N");
            mapKey.Add("","O");    mapKey.Add("","P");    mapKey.Add("","R");
            mapKey.Add("","S");    mapKey.Add("","T");    mapKey.Add("","U"); 
            mapKey.Add("","F");    mapKey.Add("","H");    mapKey.Add("","TZ");
            mapKey.Add("","CH");   mapKey.Add("","SH");   mapKey.Add("","SCH");
            mapKey.Add("","");     mapKey.Add("","Y");    mapKey.Add("","");
            mapKey.Add("","E");    mapKey.Add("","YU");   mapKey.Add("","YA");
            
            mapKey.Add("","A");    mapKey.Add("","B");    mapKey.Add("","V");
            mapKey.Add("","G");    mapKey.Add("","D");    mapKey.Add("","E");
            mapKey.Add("","YO");   mapKey.Add("","G");    mapKey.Add("","Z");
            mapKey.Add("","I");    mapKey.Add("","J");    mapKey.Add("","K");
            mapKey.Add("","L");    mapKey.Add("","M");    mapKey.Add("","N");
            mapKey.Add("","O");    mapKey.Add("","P");    mapKey.Add("","R");
            mapKey.Add("","S");    mapKey.Add("","T");    mapKey.Add("","U"); 
            mapKey.Add("","F");    mapKey.Add("","H");    mapKey.Add("","TZ");
            mapKey.Add("","CH");   mapKey.Add("","SH");   mapKey.Add("","SCH");
            mapKey.Add("","");     mapKey.Add("","Y");    mapKey.Add("","");
            mapKey.Add("","E");    mapKey.Add("","YU");   mapKey.Add("","YA");
            break;
          }
  }
  return mapKey;
}
MakeFioLat(family,name,versionTransliteration,maxLen)
{
   var mapKey = CreateObject("MapString");mapKey=SysTransliterationInit(versionTransliteration);

   char fam[256],famLat[256];
   fam=family;famLat="";
   for ( int i=0; i<strlen(fam) ;i++ )
   {
      string s = SubStr(static_cast_to_string(fam),i,1);
      if (mapKey.IsExist(s))
      {
         famLat += mapKey.GetValue(s);
      }
   }

   char im[256],imLat[256];
   im=name;imLat="";
   for ( int i=0; i<strlen(im) ;i++ )
   {
      string s = SubStr(static_cast_to_string(im),i,1);
      if (mapKey.IsExist(s))
      {
         imLat += mapKey.GetValue(s);
      }
   }

   string fioLat= to_string(imLat) + " " + to_string(famLat);
   if ( strlen(fioLat)>maxLen )
   {
      imLat[1]='.';
      imLat[2]=0;
      fioLat= to_string(imLat) + " " + to_string(famLat);
   } 
   return fioLat; 
}
//  1     .     0
//:
//    listFileds-     ,     (     -   )

AllFieldValuesIsNull(listFileds)
{
  double eps=0.00001; // 
  var subStrings = CreateObject("ParamFuncRW");
  subStrings.IInitial(to_string(listFileds),";",255);
  
  var Tabl=CreateObject("CurPrnTbl");
  int rcr=Tabl.Get_N_Rcr(); // 
  //   
  for(int fld=0;fld<Tabl.Count_Fld();fld++)
  {
    //   listFileds
    for(int idx=0;idx<subStrings.Count();idx++)
    { 
      //  fld   idx
      if ( IsSubStrPresent(Tabl.Name_Fld(fld),subStrings.Get(idx)) )
      {
        double sum= atof(Tabl.Text(fld,rcr));    
        if(nabs(sum)>eps) return 0;
      }
    }
  }
  return 1;
}
GetKassVedNumber()
{
  var ved = GetTekKassVed();            // "" 
  var vedList = CreateObject("CurPrnTbl");
  vedList.Initial(ved.GetAdrSpVed());   //  

  int idxFld=vedList.Find_Name_Fld("PRINT_NUMB");
  int rcr=vedList.Get_N_Rcr(); //      .   ,   vedList   .
  string result=vedList.Text(idxFld,rcr);
  return result;
}

unsigned gWhichBLPilotFSS=0;
string gPilotD1="";
string gPilotD2="";

AddInfoPilotToTableName(__AdrTable,__AdrMainTable,__MainTableRcr)
{
  try
  {
    if ( __AdrMainTable ) 
    {
    /*
      var Tabl = CreateObject("CurPrnTbl");
      Tabl.Initial(__AdrTable);
      int FldSumm = Tabl.Find_Name_Fld(nameFld);
      if(FldSumm==-1) return;
      int Acc=Tabl.Accurasy_Fld(FldSumm);
      
      Tabl.Fill_Bottom_Text_1();
      double Sum = atof(Tabl.Get_Bottom_Text(FldSumm));
    */
      var TablMain=CreateObject("CurPrnTbl");
      TablMain.Initial(__AdrMainTable);
      if ( __MainTableRcr>=0 && __MainTableRcr<TablMain.Count_Rcr() )
      {
        int Fld = TablMain.Find_Name_Fld("Descriptor");
        if ( Fld==-1 ) return;
        char caption[256],tmp[256];;
        caption = TablMain.Text(Fld,__MainTableRcr); FreeSpaceString(caption,3,"");
        sprintf(tmp,"%s (%s-%s)",caption,gPilotD1,gPilotD2);
        TablMain.SText(Fld,__MainTableRcr,to_string(tmp));
        TablMain.Rewrite();
      }
    }
  }
  catch(...)
  {
    ;
  }  
}

PanelBLPilotFSS()
{
   if ( !Str_Cmp(gPilotD1," "," ./") )
   {
      var Dat = CreateObject("KDate");
      Dat.SetDateD(data);
      Dat.ImproveDay();
      char Buf[81];
      sprintf(Buf,"%.10s",Dat.GetStr());
      gPilotD1 = Buf;
      Dat.SetDateII(Dat.CountDay(),Dat.GetAbs());
      sprintf(Buf,"%.10s",Dat.GetStr());
      gPilotD2 = Buf;
   }
   char Insert00[1];
   char Access00[1];
   var Text00[1];
   MakeReferenceVar(Text00[0],gPilotD1);
   Insert00[0]=Access00[0]=' ';

   char Insert01[1];
   char Access01[1];
   var Text01[1];
   MakeReferenceVar(Text01[0],gPilotD2);
   Insert01[0]=Access01[0]=' ';

   char Insert02[2];
   char Access02[2];
   string Text02[2];
   Text02[0]=" ।  ";
   Text02[1]="";
   for ( int i=0; i<2; ++i)
      Insert02[i]=Access02[i]=' ';
   Insert02[0]='\0';

   char InsertStart[1];
   char AccessStart[1];
   InsertStart[0]='\0';
   AccessStart[0]=' ';
   string TextStart="  ";

   var Elem[4];
   for ( int i=0; i<4; ++i)
      Elem[i]=CreateObject("KControlElement");
      //  砫
   Elem[0].Initial(15,2,10,1,10,1,0,0,0,E_EDIT_AREA,1,1,"Before_S",
                   "Control_S","  .  .    ",Text00,Insert00,Access00);
      //  
   Elem[1].Initial(52,2,10,1,10,1,0,0,0,E_EDIT_AREA,1,1,"Before_S",
                   "Control_S","  .  .    ",Text01,Insert01, Access01);

      //  쭨
   Elem[2].Initial(29,4,20,1,24,2,0,0,0,E_AUTO_SELECT,2,1,
                   "Before_S",  "Control_S","", Text02,Insert02,Access02);

      // ""
   Elem[3].Initial(55,6,9,1,9,1,1,0,88,E_AUTO_SELECT,1,1,
                          "Before_S", "Control_S","",TextStart, InsertStart, AccessStart);

   int ColDatK = 40;
   var Head[3];
   for ( int i=0; i<3; ++i )
      Head[i]=CreateObject("KControlHeading");
   Head[0].Initial(" 砫:",2,2,13,2,1);
   Head[1].Initial(" :",ColDatK,2,ColDatK+10,2,1 );
   Head[2].Initial(" 쭨 롨:",2,4,27,4,1);

   if ( Panel(Elem,4,Head,3,6,8,74,17,' ',5,"ControlPanel",0,"롮ઠ 쭨  ॥") == ESC )
      return ESC;
   gWhichBLPilotFSS=strlen(Insert02);
   return 0;
}

GetDatBegBLPilotFSS()
{
   unsigned Flag = 2 + (gWhichBLPilotFSS?0:4);
   string ListBL = GetListBL(gPilotD1,gPilotD2,Flag);
   var kcp = CreateObject("KPeriodsIterations");
   kcp.ClearAll();

   var Param = CreateObject("ParamFuncRW");
   Param.IInitial(ListBL,",",1000);
   for ( int i = 0; i<Param.Count(); ++i )
      kcp.AddPeriod(Param.Get(i),gPilotD1,gPilotD2);
   return 0;
}

var gGlobalBLInfo;
InitPilotBL(DateBeg)
{
   gGlobalBLInfo = 0;
   gGlobalBLInfo = CreateObject("KInfoBL");
   gGlobalBLInfo.Initial(static_cast_to_string(DateBeg));
}

SetDeliveredFlag2FSS(DateBeg)
{
   var BLInfo = CreateObject("KInfoBL");
   BLInfo.Initial(static_cast_to_string(DateBeg));
   if ( BLInfo.GetDateBeg().IsValid() )
   {
      BLInfo.SetDelivered2FSS(1);
      BLInfo.SaveParametrs();
   }
}

SetFlagFSSDelivered(&Arg,  &pcT, W, A)
{
   string DateBeg=GetVarValue(Arg);
   // ஢塞 祭  砫. ᫨   - 祣  
   if ( !Str_Cmp(DateBeg," "," ./") ) return pcT;
   var Bl=CreateObject("KInfoBL");
   Bl.Initial(to_string(DateBeg));
   // ஢塞 祭 ࠬ /. ᫨  砭  , 
   //  諨 쭨筮  ।  ⮩ 砫 - 祣  .
   if ( !Bl.GetDateEnd().IsValid() ) return pcT;
   Bl.SetDelivered2FSS(1);
   Bl.SaveParametrs();
   return pcT;
}

PilotInfo(&Arg,  &pcT, W, A)
{
   if ( IsObject(gGlobalBLInfo) )
   {
      string Rez = gGlobalBLInfo.GetStrParametrs(static_cast_to_string(Arg));
      Text_Text(pcT,Rez,W);
   }
   return pcT;
}

VidBLPilot(vidbl)
{
   int vid = atoi(static_cast_to_string(vidbl));
/*
   TYPE_BL_BOL  = 0,  ///<              
   TYPE_BL_BER  = 1,  ///<  ६  த 
   TYPE_BL_TR   = 2,  ///< ந⢥ ࠢ 
   TYPE_BL_HTR  = 3,  ///< ⮢ ࠢ          
   TYPE_BL_UHOD = 4,  ///<  室
   TYPE_BL_ABORT= 5,  ///< ⢥ 뢠 ६
   TYPE_BL_PROF = 6,  ///< ᨮ쭮   
   TYPE_BL_UH15 = 7,  ///<  室  1.5 
   TYPE_BL_KARANTIN=8,///< ࠭⨭
   TYPE_BL_SAN_KUR=9, ///< ᠭ୮-
   TYPE_BL_PROTEZ=10, ///< ⥧஢
*/
   if ( vid==1 ) return 2;
   if ( vid==2 || vid==6 ) return 6;
   return 1;
}

GetAccountInfoPilot(ps,FullStr)
{
   string value = "";
   if ( Str_Cmp(FullStr," "," .,") )
   {
      int idx = ps=="BIC"?1:(ps=="CardNum"?2:0);
      var FuncParam =  CreateObject("ParamFuncRW");
      FuncParam.IInitial1(static_cast_to_string(FullStr),",",3);
      value = FuncParam.Get(idx);
      /*
      var KchStr = CreateObject("CKchUserStruct");
      if ( KchStr.InitMain("bank_fss",static_cast_to_string(FullStr)) )
         value = KchStr.GetSubfield(ps);
      */
   }
   return value;
}

var arTypeIncome6NDFLStr = 0;
var arTypeIncome6NDFLId  = 0;
int cntTypeIncome6NDFL = 0;
InitArIncome6NDFL()
{
   arTypeIncome6NDFLStr = GetArray(" ।","௫","᪭","쭨","ਠ쭠 룮",".室, 룮","஢","稥 室","");
   arTypeIncome6NDFLId = GetArray(TI6NDFL_UNDEFINED,TI6NDFL_ZP,TI6NDFL_OTP,TI6NDFL_BL,TI6NDFL_MATV,TI6NDFL_NAT,TI6NDFL_KOM,TI6NDFL_OTHER,TI6NDFL_UNDEFINED);
   cntTypeIncome6NDFL = GetUBound(arTypeIncome6NDFLId)+1;
}

FindTypeIncome6NDFL(key,&arKey,&arValue)
{
   if ( !IsArray(arTypeIncome6NDFLId) ) InitArIncome6NDFL();
   for ( int i=0; i<cntTypeIncome6NDFL; ++i )
      if ( arKey[i]==key ) return arValue[i];
   return arValue[0];
}

IdTypeIncome6NDFL(strTypeInc)
{
   FreeSpaceString(strTypeInc,2,"");
   return FindTypeIncome6NDFL(strTypeInc,arTypeIncome6NDFLStr,arTypeIncome6NDFLId);
}

NameTypeIncome6NDFL(IDTypeInc)
{
   return FindTypeIncome6NDFL(IDTypeInc,arTypeIncome6NDFLId,arTypeIncome6NDFLStr);
}

NameTypeIncome6NDFLWin(IDTypeInc)
{
   return OemToAnsi(NameTypeIncome6NDFL(IDTypeInc));
}

PanelChoiceTypeIncome6NDFL()
{
   if ( !IsArray(arTypeIncome6NDFLId) ) InitArIncome6NDFL();
   int CountSelect = cntTypeIncome6NDFL-1;
   if ( CountSelect<1 ) return "";
   string SelectArray[CountSelect];
   int maxLen = 0;
   for ( int i = 0; i<CountSelect; ++i )
   {
      SelectArray[i]=arTypeIncome6NDFLStr[i+1];
      maxLen = MAX(maxLen,strlen(SelectArray[i]));
   }
   char InsertSelect[CountSelect];
   char AccessSelect[CountSelect];
   for ( int i=0; i<CountSelect; ++i )
      InsertSelect[i]=AccessSelect[i]=' ';
   InsertSelect[0]=0;

   char InsertStart[1];
   char AccessStart[1];
   InsertStart[0]='\0';
   AccessStart[0]=' ';
   string TextStart="  ";
   var Elem[2];
   for ( int i=0; i<2; ++i)
       Elem[i]=CreateObject("KControlElement");

   Elem[0].Initial(2,3,maxLen,1,maxLen+4,CountSelect,0,0,0,E_AUTO_SELECT,CountSelect,1,"Before_S",
                   "Control_S","",SelectArray,InsertSelect,AccessSelect);
      // ""
   Elem[1].Initial(2,3+CountSelect+2,9,1,9,1,1,0,88,E_AUTO_SELECT,1,0,
                          "Before_S", "Control_S","",TextStart, InsertStart, AccessStart);

   var Head[1];
   for ( int i=0; i<1; ++i )
         Head[i]=CreateObject("KControlHeading");
   Head[0].Initial("⥣ 室",2,1,18,1,1);
   if ( Panel(Elem,2,Head,1,25,10,55,10+CountSelect,' ',5,"ControlPanel",0,"") == ESC )
      return "";
   int Len = strlen(InsertSelect);
   return SelectArray[Len];
}

int flag6NDFL_NO_ShowWarn_PDF417=0; //  뢠 ᮮ饭  6-?
IsPDF417_Exist(bMsg,NameShb)
{
   string caption="-௫.    㬥 -";
   if ( IsObjectExists("TAXDOCPrt.TAXDOCPrint") < 1 )
   {
      if ( bMsg )
      {
         int result = AmbaMessageBox(" ⠭ ⥪  ! ⥪  ᪠  ᠩ   뫪:\nhttp://gnivc.ru/software/software_ul_fl/pdf417/\n\n३  ᠩ?",
                                     caption,MB_YESNO | MB_ICONERROR,0);
         if (result == IDYES)
            ShellExecute(0,"open","http://gnivc.ru/software/software_ul_fl/pdf417/",0,0,1);  
      }
      return false;  
   }
   // ᫨   蠡,   ஢塞 稥 蠡
   if ( Str_Cmp(NameShb," "," " ) && access(GetPathToPDF417Shb()+"\\"+NameShb,0))
   {
      if ( bMsg )
      {
         int result = AmbaMessageBox(" 室 蠡  !   ᪠  ᠩ   뫪:\nhttp://www.gnivc.ru/inf_provision/form_templates/nal_decl/\n\n३  ᠩ?",
                                     caption,MB_YESNO | MB_ICONERROR,0);

         if (result == IDYES)
            ShellExecute(0,"open","http://www.gnivc.ru/inf_provision/form_templates/nal_decl/",0,0,1);  
      }
      return false;  
   }
   return true;
}

GetPathToPDF417Shb()
{
   // 稬   ४ਨ  蠡
   // ⢥ ࠧࠡ稪  ᯮ짮 ⭮⥫ ⥩  ⠪,
   //    ࠭  ࠡ  쭥襬.  ३  
   // ᮫ (८ࠧ 㤥 ,   㤮⢠ ⭮⥫ )
   string default_shab_path= "..\\Shab417"; 
   char shab_path[256]; shab_path="";

   // ᫨    ன - ६ 
   GetCommonCnf("PATH_PDF","騥",shab_path,255);
   if ( !Str_Cmp(shab_path," "," ") ) 
   {
      //  - 饬  "⠭⭮" , ⭮⥫쭮 ZPL
      strcpy(shab_path,default_shab_path);
                         
      // ᫨  㯠  ४ਨ ஡㥬  ⠫ ⭮⥫쭮 RSCALT
      if ( access(shab_path+"\\",0) )
         shab_path = GetRscaltPath(default_shab_path);
   }
   // ८ࠧ㥬  ᮫ 
   fullpath(shab_path,shab_path,255);
   FreeSpaceString(shab_path,3," ");
   return to_string(shab_path);
}


//===============================================================
// 㭪樨 ᯮ㥬  6-  2-  ࠧ  
//===============================================================

DefineOrgByKchValue(strPodr,bStringKch,bCodOrgKch)
{
   //       ࠭ ப,  ⠪  ࠧ 뢠
   // 㭪 ८ࠧ 짮⥫
   long idOrg = 0;
   if ( bStringKch )
      idOrg = GetOrgIDByKch_NDFL(strPodr);
   else
   {
      long idPodr = atol(strPodr);
      // ᫨      id ࠧ (࣠樨)
      // ६ id  ᭮ ࠧ (  室)
      if ( !idPodr )
      {
         idPodr = Poln_Tn/sizetn;
         //  ⮬ 砥 ᫨ ࠡ⠥  樨 ࠧ-࣠
         //  ࠧ ᤥ , .. GetOrgIDByKch    㤥
         if ( bCodOrgKch ) idPodr = GetOrgForPodr(idPodr);

      }
      idOrg = GetOrgIDByKch_NDFL(idPodr);
   }
   if ( !idOrg ) idOrg = GetOrgForPodr(Poln_Tn/sizetn);

   return idOrg;
}

DefineIdOrgForIncome(TypeOKTMO,absm,CodeNU)
{
   if ( TypeOKTMO==1 || TypeOKTMO==5 )
   {
      var D = CreateObject("KDate");
      D.SetDateII(1,absm);
      // ᫨ ࠧ      
      int TypeIteration = 0;
      string ps_kch = "";
      bool bCodOrgKch = false;
      bool bStringKch = false;
      DefineParamsKchOKTMO(TypeOKTMO,TypeIteration,ps_kch,bCodOrgKch,bStringKch);
      if ( TypeIteration== 1 ) D.SetDateII(D.CountDay(),absm);
      int lenBuf=255;
      char Buf[lenBuf+1];
      string strPodr = GetKchValue(ps_kch,Buf,lenBuf,D);
      return DefineOrgByKchValue(strPodr,bStringKch,bCodOrgKch);
   }
   else if ( TypeOKTMO==2 )
      return GetOrgIDByCombine_NDFL(GetIDCombineOfCod(CodeNU));
   else if ( TypeOKTMO==3 )
      return GetOrgIDBySrc_NDFL(GetSrcOfCod(CodeNU));
   else if ( TypeOKTMO==4 )
      return GetOrgIDBySubject_NDFL(GetIDSubjectOfCod(CodeNU));

   return !Poln_Tn?0:GetOrgForPodr(Poln_Tn / sizetn);
}

DefineParamsKchOKTMO(TypeOKTMO,&TypeIteration, &ps_kch, &bCodOrg, &bStringKch)
{
   if ( TypeOKTMO!= 1 && TypeOKTMO!= 5 ) return;
   int TypeKch = GetCommonCnfInt("Type_kch","2ndfl");
   // ਧ    ࠧ  ࣠権
   bCodOrg = (TypeKch & 0x04) != 0;
   if ( bCodOrg ) TypeKch -= 4;
   bStringKch = (TypeKch & 0x08) != 0;
   if ( bStringKch) TypeKch -= 8;
   TypeIteration = TypeKch;

   char Buf[256];
   GetCommonCnf("OKTMO_kch","2ndfl",Buf,255);
   FreeSpaceString(Buf,2,"");
   ps_kch = Buf;
   // ᫨    ,  ६ ⠢筮  "ࠧ"
   if ( ps_kch=="" ) ps_kch="podr";
}

// 㭪  祭    (筮  ࠧ!) 頥 ID ࣠樨
// 㭪   ८।  
GetOrgIDByKch_NDFL(Podr)
{
   return PriorityCall("UserGetOrgIDByKch_NDFL","SysGetOrgIDByKch_NDFL",Podr);
}

SysGetOrgIDByKch_NDFL(Podr)
{
   int TypeKch = GetCommonCnfInt("Type_kch","2ndfl");
   if ( (TypeKch & 0x04)!=0 ) return Podr;
   // , ᫨   ப 祭,    짮⥫᪠
   // 㭪 UserGetOrgIDByKch_NDFL, ⮬ 窠  " 直 砩"
   if ( (TypeKch & 0x08)!=0 ) Podr = atoi(Podr);
   return GetOrgForPodr(Podr);
}

// 㭪  祭 . 頥 ID ࣠樨
// 㭪   ८।  
GetOrgIDByCombine_NDFL(Combine)
{
   return PriorityCall("UserGetOrgIDByCombine_NDFL","SysGetOrgIDByCombine_NDFL",Combine);
}
SysGetOrgIDByCombine_NDFL(Combine)
{
   return GetOrgForPodr(IntegralPodrOfCombine(Combine));
}

// 㭪  祭 筨 頥 ID ࣠樨
// 㭪   ८।  
GetOrgIDBySrc_NDFL(Src)
{
   return PriorityCall("UserGetOrgIDBySrc_NDFL","SysGetOrgIDBySrc_NDFL",Src);
}

var gIDOrgsSrcSubjCollectionNDFL = 0; // ࠭ ᯨ᪠ ᮮ⢥⢨ 筨  ꥪ - ID ࣠樨
SysGetOrgIDBySrc_NDFL(Src)
{
   if ( !IsObject(gIDOrgsSrcSubjCollectionNDFL) )
   {
      gIDOrgsSrcSubjCollectionNDFL = CreateObject("MapLong");
      gIDOrgsSrcSubjCollectionNDFL.Clear();
   }
   if ( gIDOrgsSrcSubjCollectionNDFL.IsExist(Src) )
      return gIDOrgsSrcSubjCollectionNDFL.GetValue(Src);
   for ( int i=0; i<CountOtd(); ++i )
      if ( GetDepSource(OtdCode(i))==Src )
      {
         int idOrg = GetOrgForPodr(OtdCode(i));
         gIDOrgsSrcSubjCollectionNDFL.Add(Src,idOrg);
         return idOrg;
      }   
   if ( !Poln_Tn ) return 0;
   return GetOrgForPodr(Poln_Tn/sizetn);   
}
// 㭪  祭 ꥪ 頥 ID ࣠樨
// 㭪   ८।  
GetOrgIDBySubject_NDFL(Subject)
{
   return PriorityCall("UserGetOrgIDBySubject_NDFL","SysGetOrgIDBySubject_NDFL",Subject);
}
SysGetOrgIDBySubject_NDFL(Subject)
{
   if ( !IsObject(gIDOrgsSrcSubjCollectionNDFL) )
   {
      gIDOrgsSrcSubjCollectionNDFL = CreateObject("MapLong");
      gIDOrgsSrcSubjCollectionNDFL.Clear();
   }
   if ( gIDOrgsSrcSubjCollectionNDFL.IsExist(Subject) )
      return gIDOrgsSrcSubjCollectionNDFL.GetValue(Subject);
   for ( int i=0; i<CountOtd(); ++i )
      if ( GetDepSubject(OtdCode(i))==Subject)
      {
         int idOrg = GetOrgForPodr(OtdCode(i));
         gIDOrgsSrcSubjCollectionNDFL.Add(Subject,idOrg);
         return idOrg;
      }   
   if ( !Poln_Tn ) return 0;
   return GetOrgForPodr(Poln_Tn/sizetn);   
}

DefineTypeOKTMO_NDFL()
{
   int TypeOKTMO_NDFL = GetCommonCnfInt("TypeOKTMO", "2ndfl");
/*
   // TODO  ਩ ᫥ ࠢ ⠡ 2- 
   // ⠡ 2-  ⮢  TypeOKTMO_NDFL = 5 (஢ ப?)
   if (TypeOKTMO_NDFL == 1)
   {
      string ps_kch = GetCommonCnfStr("OKTMO_kch", "2ndfl");
      // ᫨    ,  ६ ⠢筮  "ࠧ"
      if (!Str_Cmp(ps_kch, " ", " ")) ps_kch = "podr";
      int numKCH = kch_num_sys(ps_kch);
      if (numKCH >= 0 && kch_comb(numKCH)) TypeOKTMO_NDFL = 5;
   }
*/
   return TypeOKTMO_NDFL;
}

MakePaidIncomeCollection_6NDFL(MonthB,MonthE)
{  
   UnloadScriptModule("forms\\DefineEnterpriseID");
   LoadScriptModule("forms\\DefineEnterpriseID");

   var D1 = CreateObject("KDate"); D1.SetDateII(1,MonthB);
   var D2 = CreateObject("KDate"); D2.SetDateII(1,MonthE); D2.SetDateII(D2.CountDay(),MonthE);
   var kcp = CreateObject("KPeriodsIterations");
   double Tax70=0.;
   var PaidsExt = CreateObject("PaidIncomeCollection");
   PaidsExt.Initial(false);
   gTypeOKTMO_NDFL = DefineTypeOKTMO_NDFL();
   AddInfoPart2_6NDFL(0,kcp,6,Tax70,D1,D2,PaidsExt);

   UnloadScriptModule("forms\\DefineEnterpriseID");
   return PaidsExt;
}


FindSumElem(intCode,m,mv)
{
   var LS = CreateObject("LS");
   LS.GetGlobalLS();
   var MatrLS = LS.MatrLS();
   var be=MatrLS.GetBaseElemByCode(intCode);
   if (VarHasValue(be))
   {
     var sumVect=be.SumVect;
     int index=sumVect.FindRow(m,mv);
     if (index>=0)
       return sumVect.GetSum(index);
   }

   // return GetEmpty();       Empty
}

//    
//      return AddPayToSumExt(Extern_Cod, Month, MonthN, Sum, IdVed);
//              !
AddPayToSumExt(ExtCode, Month, MonthN, Sum, IdVed)
{
   if (!AddPayToSum(
         Extern_To_InternE(atof(ExtCode)),
         absmec(GetDateFromFuncRWScript(Month)),
         absmec(GetDateFromFuncRWScript(MonthN)),  Sum, IdVed))
     BreakLineDelivery();
   //  RaiseError(",      ");
}

AddPayToSum(intCode, m, mv, sum, IdVed)
{
   var sumElem = FindSumElem(intCode,m,mv);
   if (!VarHasValue(sumElem))
     return 0;
   struct PaidSumS paid;
   paid.IdVed=IdVed;
   paid.Sum=sum;
   sumElem.AddPay(paid);
   korrls=2;
   return 1;
}

DelPayFromSum(intCode, m, mv, IdVed)
{
   bool changed = false;
   var sumElem = FindSumElem(intCode,m,mv);
   if (!VarHasValue(sumElem))
     return 0;
   for(int i = 0; i<sumElem.PaysCount(); i++)
   {
      int idVed=sumElem.GetPay(i).IdVed;
      if (idVed==IdVed)
      {
        sumElem.DeletePay(i);
        i--;
        changed=true;
      }
   }
   if (!changed) 
     return 0;

   korrls=2;
   return 1;
}

//    
//      return DeletePayFromSumExt(Extern_Cod, Month, MonthN, IdVed);
DelPayFromSumExt(ExtCode, Month, MonthN, IdVed)
{
   if (!DelPayFromSum(
         Extern_To_InternE(atof(ExtCode)),
         absmec(GetDateFromFuncRWScript(Month)),
         absmec(GetDateFromFuncRWScript(MonthN)), IdVed))
     BreakLineDelivery();
}

TkDeliveryVedIdStart(&VarG)
{
  var MapPanel = CreateObject("MapString");

  MapPanel.Add("0","᪠ 믫...");
  MapPanel.Add("1"," 믫");
  var MapRez = CreateObject("MapString");

  int c=PanelValueFromMap(MapPanel,MapRez,1, "᪠ 믫");
  if (c==ESC)
  {
     return(ESC);
  }
  int reg=atoi(MapRez.GetCurKey());
  char date[11];
  date =  "  .  .    ";
  char name[256];
  name = "";
  int id=0;

  if (reg==0)
  {
   if (ESC==Panel_Zapros("  䨪⨢ ᮢ  ","",
                    "   ",date, 10, 
                    "   ",name, 50)
      ) return ESC;

    var veds = CreateObject("CashVedInfoList");
    var info=  veds.CreateVedInfo();
    info.DateStr=to_string(date);
    if (info.Date<20000000)
    {
      MsgBox("  ","",0);
      return ESC;
    }  
    info.Type = 6;
    info.Title = TrimN(OemToAnsi(name));
    id = veds.Add(info);
  }

  int params[2];
  params[0]=reg;
  params[1]=id; 
  VarG = params;
}


GetKassVedInfo(IdVed, what) // what: 0 - , 1 - , 2 - 
{
  if ( IdVed )
  {
     var cashVedInfo = CreateObject("CashVedInfoList").GetVedInfo(to_int(IdVed));
     if ( VarHasValue(cashVedInfo) )
        switch(what)
        {
          case 0: return cashVedInfo.DateStr;
          case 1: return AnsiToOem(cashVedInfo.Number);
          case 2: return AnsiToOem(cashVedInfo.Title);
        }
  }
}
CharAsString(c)
{
  char str[2];
  str[0]=c;
  str[1]=0;
  return str;
}
MapFromStr(str,Delimiter)
{
  var Map=CreateObject("MapString");      Map.Clear();
  var List = CreateObject("ParamFuncRW"); List.IInitial(to_string(str),Delimiter,9999);
  for(int i=0;i<List.Count();i++)
    Map.Add(List.Get(i),List.Get(i));
  return Map;  
}

GetQuarterNumber(date)
{
   int result = (date.GetMonth() - 1)/3;
   return result + 1;
}

GetCodPeriod6NDFL(strDate, strDateEnd, reorgCode)
// reorgCode == "-1"   GetCodPeriod6NDFL  GetCodPeriodRSV2017
{
   var Dat = KDateFromStr(strDate);
   var DateEnd = KDateFromStr(strDateEnd);
   
   int quarter =GetQuarterNumber(Dat); // Dat.GetQuarter();
   var quarterReorg = DateEnd.IsValid() ? GetQuarterNumber(DateEnd)/*DateEnd.GetQuarter()*/ : 0;

   bool bReorg;

   if ( Dat.GetYear() >= 2017 && GetCommonCnfInt("ex2017","6ndfl") == 0 && reorgCode != "-1" )
      bReorg = TrimN(reorgCode) != "";
   else
      bReorg = Dat.GetYear() == DateEnd.GetYear() && quarter == quarterReorg;

   if (quarter == 1) return bReorg?"51":"21";
   if (quarter == 2) return bReorg?"52":"31";
   if (quarter == 3) return bReorg?"53":"33";
   if (quarter == 4) return bReorg?"90":"34";
}

GetCodPeriodRSV2017(strDate, strDateEnd)
{
   return GetCodPeriod6NDFL(strDate, strDateEnd, "-1");
} 

//         
var NumbersSpravByOrgID = CreateObject("MapLong");
InitNumberSparvByOrgID(AdrTbl,psOrgID, psNum)
{
   NumbersSpravByOrgID.Clear();
   if ( AdrTbl!=0 )
   {
      var T = CreateObject("CurPrnTbl");
      T.Initial(AdrTbl);
      int FldOrg = T.Find_Name_Fld(psOrgID);
      int FldNum = T.Find_Name_Fld(psNum);
      if ( FldNum!=-1 )
         for ( int Rcr=0; Rcr<T.Count_Rcr(); ++Rcr )
         {
            int OrgID = FldOrg==-1?0:atoi(T.Text(FldOrg,Rcr));
            int Num = atoi(T.Text(FldNum,Rcr));
            int CurNum = 0; //   ,       
            CurNum = NumbersSpravByOrgID.GetValue(OrgID);
            if ( Num>CurNum ) NumbersSpravByOrgID.Add(OrgID,Num);
         }
   }
}

GetNumberSpravByOrgID(OrgID)
{
   int Number = 0; //  !  ,     .
                   //      ,     !
   Number = NumbersSpravByOrgID.GetValue(OrgID);
   ++Number;
   NumbersSpravByOrgID.Add(OrgID,Number);
   return Number;
}

GetCount2NDFLInPack(Year)
{
   int Count = GetCommonCnfInt("CountSprav","2ndfl");
   if ( Count<1 ) return 3000;
   return Count;
}
string __CardNumberKchField="";//ᥢ  ..  ஬ ࠭ " " 

DeliveryBankCardNumber(number,data,flags)
//flags & 1 - <⮥> 祭  ࠧ;
{
  var value=number; FreeSpaceString (value,3,""); 
  
  if ((flags & 1) && !strlen(value) )
    return;
  
  var deliveryDate=KDateFromStr(data);
  if(!deliveryDate.IsValid()) //᫨   㪠  㪠 ୮ - ࠧᨬ  ࢮ ᫮ ⥪. 
    deliveryDate=KDateFromInt_WithDay(1,mtek);
    
  SetKchValue(__CardNumberKchField,value,deliveryDate);
}

GetBankGlobalDialogDataCurrentTable(reAskParamsIfEmpty)
{
  string module="bank\\common";
  bool moduleWasLoaded=false;
  if ( !ScriptCheckName("GetGlobalDataCurrentTable") )
  {
    UnloadScriptModule(module);
    LoadScriptModule(module);
    moduleWasLoaded=true;
  }
  var rez=GetGlobalDataCurrentTable(reAskParamsIfEmpty);
  if(moduleWasLoaded)
    UnloadScriptModule(module);
  return rez;
}
GetBankDialogDataCurrentTable(reAskParamsIfEmpty)
{
  string module="bank\\common";
  bool moduleWasLoaded=false;
  if ( !ScriptCheckName("GetDialogDataCurrentTable") )
  {
    UnloadScriptModule(module);
    LoadScriptModule(module);
    moduleWasLoaded=true;
  }
  var rez=GetDialogDataCurrentTable(reAskParamsIfEmpty);
  if(moduleWasLoaded)
    UnloadScriptModule(module);
  return rez;
}
BankCommon_ShowDialog()
{
  string module="bank\\common";
  bool moduleWasLoaded=false;
  if ( !ScriptCheckName("Bank_ShowDialog") )
  {
    UnloadScriptModule(module);
    LoadScriptModule(module);
    moduleWasLoaded=true;
  }
  var rez=Bank_ShowDialog();
  if(moduleWasLoaded)
    UnloadScriptModule(module);
  return rez;
}
ReLoadScriptModule(module)
{
  UnloadScriptModule(module);
  LoadScriptModule(module);
}
ReLoadSMs(moduleArray)
{
  for(int i=0;i<GetUBound(moduleArray)+1;i++)
    ReLoadScriptModule(moduleArray[i]);
}
UnLoadSMs(moduleArray)
{
  for(int i=0;i<GetUBound(moduleArray)+1;i++)
    UnloadScriptModule(moduleArray[i]);
}
InitializeBankSettingsCommon(AdrTable)
{
  ReLoadScriptModule("bank\\common");
    InitializeBankSettings(AdrTable);
  UnloadScriptModule("bank\\common");
}
CommonBankFiltr(cardNumber,summ)
{
  //㪠    㬬 㫥 - 頥 1,  0
  return atoi(cardNumber)>0 && atof(summ)>0.001;   
}
CombineRef(&buffer,bufsize,handle,&C_Params)
{
  char ss[bufsize+1];
  CharToOem(buffer,ss);
  int rc=ShowCombineRef(ss,ss, 2, 5, 70, 15);
  if (rc!=ESC)
  {
      sprintf(ss,"%04d",ExtCombineToInt(ss));
      OemToChar(ss, buffer);
      return 1;
  }
  return 0;
}

TryEvaluate(script,&result)
{
  try
  {
    var xm = CreateObject("XMachine");
    result=xm.Evaluate(to_string(script)); 
    return result!="void";
  }
  catch(...)
  {
    ;
  }
  return false; 
}

GetCommonCnfS(psVar,psTable)
{
  if ( IsCommonCnfExist(psVar,psTable) )
  {
    char Buf[256];
    GetCommonCnf(psVar,psTable,Buf,255);
    FreeSpaceString(Buf,3,"");

    char tmp[256];
    if(TryEvaluate(Buf,tmp)) 
      return to_string(tmp);

    return to_string(Buf);
  }
  return "";
}
